# coding: utf-8

"""
    CCT Customer Service Requests

    API for interacting with City of Cape Town's eServices

    The version of the OpenAPI document: 2.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class RequestAttributesSchema(BaseModel):
    """
    RequestAttributesSchema
    """ # noqa: E501
    id: StrictInt
    category_1: StrictStr
    category_2: StrictStr
    suburb: StrictStr
    email: StrictStr
    message: StrictStr
    address: StrictStr
    username: StrictStr
    account_number: StrictStr
    comm: StrictStr
    latitude: StrictStr
    longitude: StrictStr
    type: StrictInt
    subtype: StrictInt
    telephone: StrictStr
    first_name: StrictStr = Field(alias="firstName")
    last_name: StrictStr = Field(alias="lastName")
    street: StrictStr
    street_number: StrictInt
    __properties: ClassVar[List[str]] = ["id", "category_1", "category_2", "suburb", "email", "message", "address", "username", "account_number", "comm", "latitude", "longitude", "type", "subtype", "telephone", "firstName", "lastName", "street", "street_number"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RequestAttributesSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RequestAttributesSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "category_1": obj.get("category_1"),
            "category_2": obj.get("category_2"),
            "suburb": obj.get("suburb"),
            "email": obj.get("email"),
            "message": obj.get("message"),
            "address": obj.get("address"),
            "username": obj.get("username"),
            "account_number": obj.get("account_number"),
            "comm": obj.get("comm"),
            "latitude": obj.get("latitude"),
            "longitude": obj.get("longitude"),
            "type": obj.get("type"),
            "subtype": obj.get("subtype"),
            "telephone": obj.get("telephone"),
            "firstName": obj.get("firstName"),
            "lastName": obj.get("lastName"),
            "street": obj.get("street"),
            "street_number": obj.get("street_number")
        })
        return _obj


